Use Case 1: Wpłata gotowki
=====================

**Aktor podstawowy: Wpłacający**


Główni odbiorcy i oczekiwania względem systemu:
-----------------------------------------------

 - Wpłacający: oczekuje możliwości szybkiej wparty pieniędzy do banku

 - Bank wydawca identyfikatora: chce otrzymać informacje o wpłacie klienta (celem zaksięgowania transakcje na koncie klienta)

 - Operator bankomatu: chce otrzymać informacje o wpłacie(celem przekazania środków dla banku), chce być informaowany o ewentualnych błędach
 
 - System identyfikatorów: dostarcza wymagane informacje o kliencie, zależy mu na bezpieczeństie transakcji
 
Warunki wstępne:
----------------

Wpalający ma prawidłowy identyfikator i może się nim autentykować. Użytkownik posiada gotówkę do wpłaty. Połaczenie z systemem banku wydawcy oraz operatora jest bez zarzutu.

Warunki końcowe:
----------------

Gotówka wpłacającego została zdeponowana w bankomacie. Bank wydawca identyfikatora został poinformowany o wpłacie. Operator bankomatu odnotował wpłatę. Użytkownik otrzymał potwierdzenie wpłaty jeśli wyraził taka wole.

Scenariusz główny (ścieżka podstawowa):
---------------------------------------

 1. Wpłacający przychodzi do ATM i autentykuje się identyfikatorem 
 2. ATM pobiera z systemu identyfikatorów wymagane informacje do przeprowadzenia tranzakcji np. bank wydawcę identyfikatora, dodatkowe dane do autentykacji
 3. autentykacja przebiega poprawnie
 4. Wpłacający wybiera opcje wpłaty gotówki
 5. Wpłacający deklaruje kwotę do wpłaty oraz jest poinformowany o limitach
 6. Wpłacający wkłada gotówkę do kieszeni ATM
 7. ATM przelicza gotówkę
 8. Wpłacający jest proszony o potwierdzenie transakcji i ja potwierdza 
 9. ATM pyta o wydanie potwierdzenia
 10. ATM deponuje gotówkę w szufladach, wykonuje transakcje wpłaty przy użyciu identyfikatora oraz informuje operatora bankomatu o transakcji
 11. ATM drukuje potwierdzenie jeśli wpłacający wyraził taka wole
 12. Klient odchodzi od ATM z identyfikatorem

Rozszerzenia (ścieżki alternatywne):
------------------------------------

 *a. W dowolnym czasie, dotyczy sytuacji kiedy system zawiesza się:
 Aby zapewnić poprawny przebieg transakcji ATM musi zapisać wszelkie dane dotyczące obecnej transakcji 
  1. ATM dokonuje restartu
  2. System odtwarza stan przed zawieszeniem się 
   1. System wykrywa błędy: 
    1.  System wyświetla informację o błędzie wpłacajcemu, zapisuje błąd, zwraca wszelkie pobrane rzeczy np. identyfikator, jeśli wymaga wlozenia, gotówkę,etc. oraz resetuje się
    2.  Jeśli jest to możliwe to klient moż dokonać kolejnej tranzakcji  


 1a. Błędny identyfikator:
  1. System sygnalizuje błąd i odrzuca identyfikator

3a.Błedna autentykacja :
 1.	System sygnalizuje błąd, odrzuca autentykacje i zatrzymuje identyfikator w razie potrzeby

7a. banknoty są w złym stanie
 1.	Wpłacający wkłada gotówkę do kieszeni
 2.	ATM nie może przliczyć gotówki
 3.	Informuje o będzie użytkownika oraz proponuje rozwiązanie(np. anulowanie 
 
2,10a. ATM nie może polaczyć się z systemem zewnetrznym
  1. ATM informuje o błędzie wpłacającego  
  2. ATM anuluje tranzakcje

1-9a. Wpłacający anuluje tranzakcje  
 1. Wplacajacy może w dowolnym momencie przed zakończeniem tranzakcji anulować ja

10b.Bank wydawca odżuca tranzakcje:
  1. ATM informuje o błędzie wpłacającego
  2. ATM anuluje tranzakcje
  3. zwraca gotówke


Wymagania specjalne:
--------------------

-	Liczarka banknotów musi działać poprawnie
-	Urządzenie reaguje na próby fizycznego naruszenia
-	Urządzenie ma czytelny ekran pokryty powloką typu privace


Wymagania technologiczne oraz ograniczenia na wprowadzane dane:
---------------------------------------------------------------

1. W przypadku karty: pin jest z przedziału 4-8 znaków
2. W przypadku karty: pin jest wprowadzany na klawiaturze numerycznej typu EPP zgodnym z PCI PTS
3. Potwierdzenie wpłaty realizowane drukowane jest na papierze
4. system umożliwia deponowanie banknotów w kieszeniach służących do wypłaty
5. Oprogamowanie powinno być audytowane zgodnie z standsardami dostawcy identyfikatorów np. PCI PA-DSS/DSS


Kwestie otwarte:
----------------

-	Co jest identyfikatorem?? (prawdopodobnie karta)
-	Kwestie bezpieczeństwa transakcji 
-	Jakie protokoły maja być użyte do komunikacji z usługami zewnętrznymi

