## Use Case 2: Wypłata gotówki

### Aktor podstawowy (Primary actor):
Klient

### Główni odbiorcy i oczekiwania względem systemu:
-	Klient: oczekuje możliwości szybkiej wypłaty gotówki, poprawności przy wydawaniu banknotów, nieinwazyjnych środków bezpieczeństwa
-	Przedsiębiorstwa bankowe: chcą poprawności realizowanych transakcji, szczególnie blokowania na kontach poprawnej ilości środków, zadowolenie Klienta oraz bezpieczeństwa wykonywanych transakcji.
-	Właściciel bankomatu: zadowolenie Klienta, poprawne naliczanie prowizji

### Warunki wstępne:
*brak*

### Warunki końcowe: 
Wypłacona została poprawna ilość banknotów. Kwota została poprawnie odjęta z konta. Wydrukowane zostało potwierdzenie wypłaty.

### Scenariusz główny (ścieżka podstawowa):

1. Klient przychodzi do bankomatu z kartą przypisaną do konta z którego mają zostać wypłacone pieniądze
2. Klient wkłada kartę do bankomatu
3. Bankomat potwierdza, że karta jest poprawną kartą bankomatową
4. Bankomat prosi Klienta o PIN
5. Klient podaje poprawny PIN
6. Klient wybiera funkcję „Wypłata Gotówki”
7. Klient podaje kwotę, którą chce wypłacić
8. Z konta Klienta odejmowana jest wypłacana kwota wraz z prowizją
9. Bankomat wydaje banknoty
10. Bankomat wydaje potwierdzenie wypłaty
11. Bankomat wydaje kartę

### Rozszerzenia (ścieżki alternatywne): 
*a. W dowolnym momencie, bankomat nie jest sprawny: <br>
&emsp; 1. Trwające transakcje zostają przerwane <br>
&emsp; 2. Bankomat przechodzi w tryb awaryjny <br>
&emsp; 3. Wydawana jest karta Klienta <br>
&emsp;&emsp; 3a. Karta Klienta nie może zostać wydana: <br>
&emsp;&emsp;&emsp; 1.	Bankomat wyświetla informacje o awarii wraz z kontaktem w celu umożliwienia odzyskania Karty <br>
3a. Karta nie jest poprawną kartą bankomatową: <br>
&emsp; 1. Bankomat podaje komunikat o nieprawidłowej karcie, po czym zwraca kartę. <br>
5a. Podany PIN jest nieprawidłowy: <br>
&emsp; 1. Bankomat prosi po ponowne podanie PINu &emsp; *powrót do punktu 4* <br>
&emsp;&emsp; 1a. Podano trzykrotnie nieprawidłowy PIN: <br>
&emsp;&emsp;&emsp; 1. Karta zostaje zablokowana, po czym zostaje zwrócona. <br>
7a. Podana kwota nie jest podzielna przez 10: <br>
&emsp; 1. Bankomat wyświetla komunikat o błędnej kwocie <br>
&emsp; 2. Bankomat prosi o powtórne podanie kwoty &emsp; *powrót do punktu 7* <br>
7b. Podana kwota nie może zostać wypłacona za pomocą zdeponowanych banknotów: <br>
&emsp; 1. Bankomat wyświetla komunikat o niewystarczającej ilości banknotów <br>
&emsp; 2. Bankomat prosi o powtórne podanie kwoty &emsp; *powrót do punktu 7* <br>
8b. Na koncie Klienta nie ma wystarczającej ilości środków: <br>
&emsp; 1. Bankomat wyświetla komunikat o niewystarczającej ilości środków na koncie <br>
&emsp; 2. Bankomat zwraca kartę <br>

### Wymagania specjalne:
- Przy braku wykonanych akcji przez 30s trwające transakcje powinny zostać przerwane a karta zwrócona.
- Wielojęzyczny interfejs

### Wymagania technologiczne oraz ograniczenia na wprowadzane dane:


### Kwestie otwarte:
 - Czy możliwa jest zmiana prowizji?
 - Czy umożliwiamy wypłatę innych walut?

