Use Case 5: Sprawdzenie stanu konta
=====================

**Aktor podstawowy:** Klient banku


Główni odbiorcy i oczekiwania względem systemu:
-----------------------------------------------

 - Klient banku: oczekuje możliwości szybkiego wprowadzania danych, braku błędów oprogramowania i uzyskania aktualnych inforamcji o stanie konta

 - Przedsiębiorstwo bankowe: chce poprawnie realizowanej wymiany informacji z bankomatem, zadowolenia klienta i tolerancji oprogramowania na możliwe opóźnienia w przesyle danych

 - Konserwator: oczekuje otrzymywania wezwań do konkretnej maszyny tylko wtedy, gdy jest ona uszkodzona


Warunki wstępne:
----------------

- Klient posiada pewne elementy, którymi zamierza zidentyfikować się i uwierzytelnić w programie bankomatu.

- Konserwator posiada urządzenie do odbioru informacji od bankomatu.

Warunki końcowe:
----------------

Podane przez bankomat inforamcje są bezpieczne i aktualne.

Scenariusz główny (ścieżka podstawowa):
---------------------------------------

 1. Klient podchodzi do bankomatu i identyfikuje swoją tożsamość
 2. Po zaakceptowaniu tożsamości przez bankomat klient uwierzytelnia się
 3. Bankomat wyświetla listę dostępnych dla klienta opcji
 4. Klient wybiera opcję sprawdzenia stanu konta
 5. Bankomat wyświetla aktualny stan konta wraz z historią ostatnich płatności i przyciskiem do jej rozwinięcia
 6. Klient wybiera opcję zakończenia podglądu stanu konta
 7. Bankomat powraca do widoku listy dostępny opcji
 8. Klient wybiera opcję zakończenia sesji
 9. Bankomat wydaje klientowi dowód tożsamości i identyfikator

Rozszerzenia (ścieżki alternatywne):
------------------------------------

 *a. W dowolnym czasie, dotyczy sytuacji awarii osprzętu bankomatu lub zawieszenia się systemu:

   1. Bankomat próbuje wydać klientowi dowód tożsamości i uwierzytelnienia
   2. Bankomat przechodzi w stan awaryjny uniemożliwiając jego używanie dla klientów
   3. Bankomat wyświetla ekran awarii urządzenia.

 1a. Błąd podczas identyfikacji użytkownika:

   1. Bankomat wyświetla klientowi ekran błędu identyfikacji i zwraca dowód tożsamości

 2a. Błąd podczas uwierzytelniania klienta:

   1. Bankomat wyświetla klientowi ekran błędu uwierzytelnienia i zwraca dowód uwierzytelniający

 3a. Brak opcji wyświetlenia stanu konta

   1. Jeżeli użytkownik nie ma uprawnień do wyświetlenia stanu konta, opcja ta nie zostaje wyświetlona na ekranie

 5a. Wybór przycisku do rozwinięcia historii transakcji:

   1. Bankomat wyświetla przewijalną listę transakcji wraz z możliwością sortowania
   2. Po przeczytaniu interesujących informacji klient wybiera przycisk wyjścia z podglądu historii
   3. Bankomat powraca do wyświetlania aktualnego stanu konta ze skróconą historią


Wymagania specjalne:
--------------------

 - Tekst na ekranie dotykowym powinien być duży i dobrze widoczny, a za razem ciężki do odczytania stojąc z boku automatu

 - Bankomat powinien posiadać interfejs wielojęzyczny możliwy do zmienienia na życzenie przedsiębiorstwa bankowego

 - Wyświetlanie stanu konta powinno nastąpić w przeciągu około 2 sekund od wybrania tej opcji w bankomacie

Wymagania technologiczne oraz ograniczenia na wprowadzane dane:
---------------------------------------------------------------

 1a. Identyfikacja zachodzi za pośrednictwem karty

 2a. Uwierzytelnianie zachodzi za pośrednictwem wpisania na klawiaturze bankomatu numeru PIN

 2b. Pin składa się z 4 cyfr i jest wyświetlany na oddzielnym ekranie bankomatu


Kwestie otwarte:
----------------

 - Czy oprogramowanie bankomatu ma mieć możliwość odgrywania dźwięków?

 - Jak różnorodne formy identyfikacji i autoryzacji mogą być obsługiwane?

 - W jaki sposób bankomat powinien informować konserwatora o awarii?
